package Msm::Admin::MySql;

use strict;

sub new{
	my $self=shift;
	my $admin=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{Admin}=$admin;

	return $hash;
}

sub viewUser(){
	my $self=shift;
	my $cgi=$self->{Admin}->getCGI();

	my $db=$self->{Admin}->getDB();

	my @line=$db->execute(q{SELECT id,data from user WHERE  name_1='default' and name_2='user'});

	my $val=undef;
	foreach my $href(@line){
		$val.='<tr><td>'.$href->{id}.'</td><td><a href="'.$self->{Admin}->getConfigData('','adminscript').'?t=admin/usereditinput&amp;mode=usereditinput&amp;userid='.$href->{id}.'&amp;authid='.$cgi->param('authid').'">'.$href->{data}.'</a></td></tr>';
	}


	$self->{Admin}->setData('viewUser','all',$val);
}

sub viewBlog{
	my $self=shift;
	my $cgi=$self->{Admin}->getCGI();

	my $db=$self->{Admin}->getDB();

	my @line=$db->execute(q{SELECT id,data from blog WHERE  name_1='default' and name_2='staticindexurl'});


	my $val=undef;
	foreach my $href(@line){
		$val.='<li><a href="'.$self->{Admin}->getConfigData('','adminscript').'?t=admin/blogsettinginput&amp;blogid='.$href->{id}.'&amp;mode=blogsettinginput&amp;authid='.$cgi->param('authid').'">'.$href->{data}.'</a></li>';
	}


	$self->{Admin}->setData('viewBlog','all',$val);

}

sub setBlogs{
	my $self=shift;
	my $cgi=$self->{Admin}->getCGI();

	my $db=$self->{Admin}->getDB();

	my @line=$db->execute('select distinct id from blog order by id');
	my $val=undef;
	foreach my $href(@line){
		my $id=$href->{id};
		my $config=new Msm::Config('blog_'.$id,$self->{Admin}->getConfig,$self->{Admin}->getDB());
		$val.='<li><a href="'.$self->{Admin}->getConfigData('','script').'?blogid='.$id.'">'.$config->getConfigData('','msname').'</a></li>';
	}

	$self->{Admin}->setData('Blogs','all',$val);
}

sub getBlogsID{
	my $self=shift;
	my @id=();

	my $db=$self->{Admin}->getDB();

	my @line=$db->execute('select distinct id from blog order by id');
	my $val=undef;
	foreach my $href(@line){
		my $id=$href->{id};
		push @id,$id;
	}

	return @id;
}

1;
