package Msm::Backup::MySql;

use strict;
use Msm::XmlParse;

sub new{
	my $self=shift;
	my $back=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{Backup}=$back;

	return $hash;
}

sub setTimestamp{
	my $self=shift;
}

sub recoveryData{
	my $self=shift;
	my $xml=shift;
	my $option=shift;
	my $MShash=$self->{Backup}->getMS();
	my $ddir=$MShash->getDataDir();
	my $bid=$MShash->getCGI->param('blogid');

	my $db=$MShash->getDB();
	#ɋL폜ƂiftHgj̏
	unless($option){
		#܂S폜ȁH
		$db->execute('delete from sketch_dir');
		$db->execute('delete from sketch');
	}

	my $parse=new Msm::XmlParse($xml,$MShash);
	my $rnode=$parse->getRootNode();
	my @cnode=$rnode->getChildNodes();
	foreach my $file(@cnode){
		my @val=$file->getChildNodes();
		my $name=$val[0]->getValue();
		if($name!~/\.\./){
			my $time=$val[1]->getValue();
			my $title=$val[2]->getValue();
			my $come=$val[3]->getValue();
			my $filen='';
			my $dir='';
			if($name=~/^(\/.+)\/(.+)\.txt$/){
				$dir=$1;
				$filen=$2;
			}

			$MShash->createDataDir($dir.'/'.$file,time);
			$db->execute('insert into sketch values(?,?,?,?,?,?)',($bid,$dir,$filen,$file->unescape($title),$file->unescape($come),$time));
		}
	}
	return;
}

sub recoveryPlugData{
	my $self=shift;
	my $xml=shift;
	my $option=shift;
	my $MShash=$self->{Backup}->getMS();
	my $bid=$MShash->getCGI->param('blogid');

	my $db=$MShash->getDB();
	#ɃvOCf[^폜ƂiftHgj̏
	unless($option){
		#܂S폜ȁH
		$db->execute('delete from plug_dir');
		$db->execute('delete from plug');
	}

	my $parse=new Msm::XmlParse($xml,$MShash);
	my $rnode=$parse->getRootNode();
	my @cnode=$rnode->getChildNodes();
	foreach my $file(@cnode){
		my @val=$file->getChildNodes();
		my $plug=$val[0]->getValue();
		my $name=$val[1]->getValue();
		if($name!~/\.\./){
			my $filen=$name;
			my $dir='';
			if($name=~/^(\/.+)\/(.+)$/){
				$dir=$1;
				$filen=$2;
			}
			my $value=$val[2]->getValue();

			$MShash->writePlugData($plug,$dir,$filen,$file->unescape($value));
		}
	}
	return;
}

1;
