package Msm::Config::File;

use strict;
use Msm::IO;

sub new{
	my $self=shift;
	my $config=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{Config}=$config;

	return $hash;
}

sub readConfig(){
	my $self=shift;
	unless(-e './ini/'.$self->{Config}->{FILENAME}.'.cgi'){
		$self->{Config}->{NEW}=1;
	}

	my @line=new Msm::IO('','')->readFileArray('./ini/'.$self->{Config}->{FILENAME}.'.cgi');

	foreach my $line(@line){
		$line=~s/\r\n$/\n/;
		chomp $line;
		if($line =~ /^([^#].*?)\.(.*?)=(.*)=(.*)/o){
			my $plug=$1;
			my $name=$2;
			my $info=$3;
			my $data=$4;
			#Array
			if($data =~ /\((.*)\)/){
				my @data=();
				push @data,$1 while($data =~ /'(.*?)'/go);
				$data=\@data;
			}
			if($name eq 'staticindexurl'){
				$data=~s/^http:\/\/.*?(\/.*)$/$1/;
			}

			$self->{Config}->setConfigData($plug,$name,$info,$data);
		}
	}
}

sub rewriteConfig(){
	my $self=shift;
	my $hash=shift;
	my $fileperm=shift;

	my $out='';
	foreach my $v(@{$self->{Config}->{LIST}}){
		my($plug,$name)=split(/\./,$v);
		if(ref($hash->{$plug}->{$name}->{value}) eq 'ARRAY'){
			my $value='(';
			foreach(@{$hash->{$plug}->{$name}->{value}}){
				$value.=q{'}.$_.q{',};
			}
			$value=~s/,$//;
			$value.=')';
			$out.=$plug.'.'.$name.'='.(defined($hash->{$plug}->{$name}->{info})?$hash->{$plug}->{$name}->{info}:'').'='.$value."\n\n";
		}else{
			$out.=$plug.'.'.$name.'='.(defined($hash->{$plug}->{$name}->{info})?$hash->{$plug}->{$name}->{info}:'').'='.(defined($hash->{$plug}->{$name}->{value})?$hash->{$plug}->{$name}->{value}:'')."\n\n";
		}
	}

	new Msm::IO($fileperm,'')->writeFile('./ini/'.$self->{Config}->{FILENAME}.'.cgi',$out);
	$self->{Config}->_readConfig();
}

1;
