package Msm::IO;

use strict;
sub new{
	my $self=shift;
	my $fileperm=shift;
	my $dirperm=shift;
	my $hash={};
	$hash->{FILEPERM}=$fileperm;
	$hash->{DIRPERM}=$dirperm;
	bless $hash,$self;
	return $hash;
}

sub createDir{
	my $self=shift;
	my $filedir=shift;
	my $gdir='';
	my $dirloop=0;

	while($filedir=~m/^(.+?)(\/.+)/){
		$dirloop++;
		if($dirloop > 50){
			die 'dir deep error';
		}
		$gdir.=$1;
		$filedir=$2;
		unless(-e $gdir){
			mkdir $gdir,oct($self->{DIRPERM});
		}
	}
}

sub readFileArray{
	my $self=shift;
	my $file=shift;
	open(IN,$file) || return ();
	my @line=<IN>;
	close(IN);
	return @line;
}

sub readFile{
	my $self=shift;
	my $file=shift;
	my $bin=shift;
	my $value='';
	open(IN,$file);
	if($bin){
		binmode(IN);
	}
	$value.=$_ while(<IN>);
	close(IN);
	return $value;
}


sub writeFile{
	my $self=shift;
	my $file=shift;
	my $value=shift;
	my $bin=shift;

	#print "io-> $file<br>";
	$value='' if !defined($value);

	open(OUT,">".$file) || die "$file not write";
	if($bin){
		binmode(OUT);
	}
	seek(OUT,0,0);
	print OUT $value;
	close(OUT);

	chmod oct($self->{FILEPERM}),$file;
}

sub writeFileAdd{
	my $self=shift;
	my $file=shift;
	my $value=shift;

	#print "io-> $file<br>";

	open(OUT,">>".$file) || die "$file not write";
	print OUT $value;
	close(OUT);


	chmod oct($self->{FILEPERM}),$file;
}

1;
