package Msm::MySketch::MySql;

use strict;
#use Time::HiRes qw/gettimeofday tv_interval/;
use Time::Local;
use Msm::CGI;


sub new{
	my $self=shift;
	my $ms=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{MS}=$ms;

	return $hash;
}

sub createDataDir{
	my $self=shift;
	my $file=shift;
	my $date=shift;
	my $db=$self->{MS}->getConfig->getDB();

	my $dirloop=0;
	my $tdir='';
	while($file=~/^(\/.*?)(\/.*)$/g){
		$dirloop++;
		if($dirloop > 50){
			die 'dir deep error';
		}
		$tdir.=$1;
		$file=$2;
		my @line=$db->execute('select * from sketch_dir where blogid=? and dir=?',
		($self->{MS}->getCGI->param('blogid').'',$tdir));
		if(@line){
		}else{
			$db->execute('insert into sketch_dir values(?,?,?)',
			($self->{MS}->getCGI->param('blogid').'',$tdir,$date));
		}
	}

}


sub updateDataDir{
	my $self=shift;
	my $dir=shift;
	my $date=shift;
	my $db=$self->{MS}->getConfig->getDB();
	$db->execute('update sketch_dir set date=? where blogid=? and dir=?',
		($date,$self->{MS}->getCGI->param('blogid').'',$dir));
}


#Lt@Cǂݍ
sub getSketchFiles{
	my $self=shift;
	my $dir=shift;	#fBNgw
	my $file=shift;	#t@Cw
	my $s_date=shift;	#Jnt
	my $e_date=shift; #It
	my $hash={};
	my $db=$self->{MS}->getConfig->getDB();
	my $sql='';
	my @col=();
	if($file){
		if($file!~/\.\./){
			$sql='select * from sketch where blogid=? and dir=? and file=?';
			push @col,($self->{MS}->getCGI->param('blogid').'',$dir,$file);
		}
	}elsif($dir){
		if($dir!~/\.\./){
			$sql='select * from sketch where blogid=? and dir=?';
			push @col,($self->{MS}->getCGI->param('blogid').'',$dir);
		}
	}else{
		$sql='select * from sketch where blogid=?';
		push @col,($self->{MS}->getCGI->param('blogid').'');
	}

	#tōiB
	if(($s_date) && ($e_date)){
		$sql.=' and date>=? and date<=?';
		push @col,($s_date,$e_date);
	}

	$sql.=' ';

	#my $start=[gettimeofday];

	my @line=$db->execute($sql,@col);
	foreach my $href(@line){
		$hash->{$self->{MS}->getDataDir().$href->{dir}.'/'.$href->{file}.'.txt'}=$href->{date};
	}

	#my $end=[gettimeofday];
	#my $speed=tv_interval($start, $end);
	#printf "sql time($sql,@col) %.6f b<br>\n", $speed;


	$self->{MS}->{GetDataFileAll}=$hash;

	return $hash;
}

sub getSketchData{
	my $self=shift;
	my $file=shift;
	my $ddir=$self->{MS}->getDataDir();
	my $db=$self->{MS}->getConfig->getDB();

	if($file =~ /^$ddir(.*)\/(.*)\.txt$/ ){
		my @line=$db->execute('select * from sketch where blogid=? and dir=? and file=?',
		($self->{MS}->getCGI->param('blogid').'',$1,$2));
		return $line[0];
	}

	return {};
}


sub getAllDirs{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;

	if($self->{MS}->{GetDataDirAll}){
		return $self->{MS}->{GetDataDirAll};
	}
	$self->{MS}->{GetDataDirAll}=$self->{MS}->getAllDirsNoCache($dir,{});
	return $self->{MS}->{GetDataDirAll};
}

sub getAllDirsNoCache{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;
	my $d=$self->{MS}->getDataDir();

	$dir=~s/^$d//;

	my $db=$self->{MS}->getConfig->getDB();
	my @line=$db->execute('select * from sketch_dir where blogid=? order by dir,date',
	($self->{MS}->getCGI->param('blogid').'')
	);


	foreach my $v(@line){
		$dircheck->{$d.$v->{dir}}=$v->{date};
	}

	$self->{MS}->{GetDataDirAll}=$dircheck;

	return $dircheck;
}

sub getDirs{
	my $self=shift;
	my $dir=shift;
	my $dirs=shift;

	my $d=$self->{MS}->getDataDir();
	$dir=~s/^$d//;

	my $db=$self->{MS}->getConfig->getDB();
	my @line=$db->execute("select * from sketch_dir where blogid=? and dir like '$dir\_%' order by dir,date",
	($self->{MS}->getCGI->param('blogid').'')
	);

	foreach(@line){
		$dirs->{$self->{MS}->getDataDir().$_->{dir}}=$_->{date};
	}
	return $dirs;

}

#fBNgLǂݍ
sub getDirFiles{
	my $self=shift;
	my $dir=shift;
	my $files=shift;
	my $cache={};

	#cacheǂݍ݁B
	if($self->{MS}->{GetDataFile}->{$dir}){
		return $self->{MS}->{GetDataFile}->{$dir};
	}

	my $d=$self->{MS}->getDataDir();
	$dir=~s/^$d//;

	my $db=$self->{MS}->getConfig->getDB();

	my @line=$db->execute('select dir,file,date from sketch where blogid=? and dir=?',
	($self->{MS}->getCGI->param('blogid').'',$dir)
	);
	foreach(@line){
		$files->{$self->{MS}->getDataDir()."$_->{dir}/$_->{file}.txt"}=$_->{date};
		$cache->{$self->{MS}->getDataDir()."$_->{dir}/$_->{file}.txt"}=$_->{date};
	}
	#cache
	$self->{MS}->{GetDataFile}->{$dir}=$cache;

	return $files;
}

sub getDirFilesData{
	my $self=shift;
	my $dir=shift;
	my $files={};

	my $d=$self->{MS}->getDataDir();
	$dir=~s/^$d//;

	my $db=$self->{MS}->getConfig->getDB();

	my @line=$db->execute('select dir,file,title from sketch where blogid=? and dir=?',
	($self->{MS}->getCGI->param('blogid').'',$dir)
	);

	foreach(@line){
		$files->{$d."$_->{dir}/$_->{file}.txt"}=$_;
	}

	return $files;
}

sub getDirCnt{
	my $self=shift;
	my $dir=shift;

	#cacheǂݍ݁B
	if($self->{MS}->{GetDataFile}->{$dir}){
		return keys %{$self->{MS}->{GetDataFile}->{$dir}};
	}

	my $d=$self->{MS}->getDataDir();
	$dir=~s/^$d//;

	my $db=$self->{MS}->getConfig->getDB();

	my @line=$db->execute('select count(blogid) as cnt from sketch where blogid=? and dir=?',
	($self->{MS}->getCGI->param('blogid').'',$dir)
	);

	return $line[0]->{cnt};
}

sub getDataDate{
	my $self=shift;
	my $fullname=shift;
	my $db=shift;
	my $ddir=$self->{MS}->getDataDir();
	if($fullname =~ /^$ddir(.*)\/(.*)\.txt$/	){
		my @line=$db->execute('select * from sketch where blogid=? and dir=? and file=?',
		($self->{MS}->getCGI->param('blogid').'',$1,$2));
		return $line[0]->{date};
	}
	return time;
}

#LbV̕ύX
sub changeCache{
	my $self=shift;
	my $fullname=shift;
	my $db=$self->{MS}->getConfig->getDB();

	my $time=$self->getDataDate($fullname,$db);
	my $ddir=$self->{MS}->getDataDir();
	if($fullname =~ /\.txt$/){
		if($self->{MS}->{GetDataFileAll}){
			$self->{MS}->{GetDataFileAll}->{$fullname}=$time;
		}
		if($fullname=~/^($ddir\/.+)\/.+/){
			my $tmp=$1;
			if($self->{MS}->{GetDataFile}){
				$self->{MS}->{GetDataFile}->{$tmp}->{$fullname}=$time;
			}
			if($self->{MS}->{GetDataDirAll}){
				$self->{MS}->{GetDataDirAll}->{$tmp}=$self->getDataDate($tmp,$db);
				while($tmp=~/^($ddir\/.+)\/.+/){
					$tmp=$1;
					$self->{MS}->{GetDataDirAll}->{$tmp}=$self->getDataDate($tmp,$db);
				}
			}
		}
	}else{
		if($self->{MS}->{GetDataDirAll}){
			$self->{MS}->{GetDataDirAll}->{$fullname}=$time;
		}
	}
}

sub createSketch{
	my $self=shift;
	my $dir=shift;
	my $file=shift;
	my $title=shift;
	my $comment=shift;
	my $date=shift;

	$self->_createSketch($dir,$file,$title,$comment,$date,1);

}

sub createSketchNoRemake{
	my $self=shift;
	my $dir=shift;
	my $file=shift;
	my $title=shift;
	my $comment=shift;
	my $date=shift;

	$self->_createSketch($dir,$file,$title,$comment,$date,0);

}

#L֘A
sub _createSketch{
	my $self=shift;
	my $dir=shift;
	my $file=shift;
	my $title=shift;
	my $comment=shift;
	my $date=shift;
	my $remake=shift;

	my $db=$self->{MS}->getConfig->getDB();

	my $utime=time;


	$self->createDataDir($dir.'/'.$file,$utime);

	my $motodate=undef;
	my @line=$db->execute('select * from sketch where blogid=? and dir=? and file=?',
	($self->{MS}->getCGI->param('blogid').'',$dir,$file)
	);
	if(defined($line[0])){
		$motodate=$line[0]->{date};
		$utime=$line[0]->{date};
	}
	if($date){
		my $dy=substr($date,0,4);
		my $dm=substr($date,4,2);
		my $dd=substr($date,6,2);
		my $dh=substr($date,8,2);
		my $dmin=substr($date,10,2);
		my $ds=substr($date,12,2);
		$utime=timelocal($ds,$dmin,$dh,$dd,$dm-1,$dy);
	}

	$db->execute('replace into sketch values(?,?,?,?,?,?)',
	($self->{MS}->getCGI->param('blogid').'',$dir,$file,$title,$comment,$utime)
	);

	if($remake){
		$self->{MS}->{NewFile}->{dir}=$dir;
		$self->{MS}->{NewFile}->{file}=$file;
		$self->{MS}->{NewFile}->{title}=$title;
		$self->{MS}->{NewFile}->{comment}=$comment;
	}

	#$self->{MS}->clearCache();	LbVNAႤƏdȂ̂ŕύX
	my $fullname=$self->{MS}->getDataDir()."$dir/$file.txt";
	$self->{MS}->changeCache($fullname);

	if($remake){
		#t@CCtH
		$self->{MS}->createFileInfoFromCache();

		#t@CtύXꍇ͂̑Ô̂XVȂƂȂB
		if(($motodate) && ($date)){
			my $static=new Msm::StaticHtml($self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig());
			my $ms=new Msm::MySketch(new Msm::CGI(),$self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig(),$self->{MS}->getDB(),$self->{MS}->{JCode});
			my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($motodate);
			$year+=1900;
			$mon++;
			my $hdate=sprintf('%04d/%02d/%02d',$year,$mon,$day);
			$static->createMonth($hdate,$ms,'1');
			$static->createDay($hdate,$ms,'1');
		}

		#蒼
		new Msm::StaticHtml($self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig())->createSketchAll("$dir/$file",$self->{MS}->{JCode});

		#RSSXV
		if($self->{MS}->getConfig->getConfigData('default','rssnocreate') eq '1'){
			new Msm::RSS()->createSketchRSS($self->{MS},$self->{MS}->getSketchFiles(),$self->{MS}->getConfigData('','rsscode'),'');
		}
	}
}

sub _clearSketchAndDir{
	my $self=shift;
	my $file=shift;
	my $remake=shift;

	my $ddir=$self->{MS}->getDataDir();
	$file=$ddir.$file;
	my $db=$self->{MS}->getConfig->getDB();

	if($file =~ /^$ddir(.*)\/(.*)\.txt$/ ){
		$db->execute('delete from sketch where blogid=? and dir=? and file=?',
		($self->{MS}->getCGI->param('blogid').'',$1,$2));

		$self->{MS}->deleteCache($self->{MS}->getDataDir().$file);

		if($remake){
			#t@CCtH
			$self->{MS}->createFileInfoFromCache();
			#蒼
			new Msm::StaticHtml($self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig())->createSketchAll("$file",$self->{MS}->{JCode});

			if($self->{MS}->getConfig->getConfigData('default','rssnocreate') eq '1'){
				new Msm::RSS()->createSketchRSS($self->{MS},$self->{MS}->getSketchFiles(),$self->{MS}->getConfigData('','rsscode'),'');
			}
		}
	}elsif($file =~ /^$ddir(.*)$/){

		my @line=$db->execute("select 1 from sketch where blogid=? and dir like '$1%'",
		($self->{MS}->getCGI->param('blogid').''));
		if(@line){

		}else{

			$db->execute("delete from sketch_dir where blogid=? and dir like '$1%'",
			($self->{MS}->getCGI->param('blogid').''));

			$self->{MS}->deleteCache($self->{MS}->getDataDir().$file);
			if($remake){
				#t@CCtH
				$self->{MS}->createFileInfoFromCache();
				#蒼
				new Msm::StaticHtml($self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig())->createSketchAll("$file",$self->{MS}->{JCode});
			}
		}
	}
}

sub clearSketchAndDir{
	my $self=shift;
	my $file=shift;

	$self->_clearSketchAndDir($file,1);
}

sub clearSketchAndDirNoRemake{
	my $self=shift;
	my $file=shift;

	$self->_clearSketchAndDir($file,0);
}

sub createFileInfo{
	my $self=shift;
}

sub createFileInfoFromCache{
	my $self=shift;
}

sub readFileInfo{
	my $self=shift;
	my $hash={};
	return $hash;
}

sub createPlugDir{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $db=$self->{MS}->getConfig->getDB();
	$dir='' if !defined($dir);
	$plug='' if !defined($plug);

	my @line=$db->execute(q{select * from plug_dir where blogid=? and plug=? and dir=''},
	($self->{MS}->getCGI->param('blogid').'',$plug));
	if(@line){
	}else{
		$db->execute('insert into plug_dir values(?,?,?)',
		($self->{MS}->getCGI->param('blogid').'',$plug,''));
	}
	my $tdir='';
	while($dir=~/^(\/.*?)(\/.*)$/g){
		$tdir.=$1;
		$dir=$2;
		my @line=$db->execute('select * from plug_dir where blogid=? and plug=? and dir=?',
		($self->{MS}->getCGI->param('blogid').'',$plug,$tdir));
		if(@line){
		}else{
			$db->execute('insert into plug_dir values(?,?,?)',
			($self->{MS}->getCGI->param('blogid').'',$plug,$tdir));
		}
	}
}

sub writePlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;
	my $data=shift;

	$self->createPlugDir($plug,$dir.'/'.$file);
	my $db=$self->{MS}->getConfig->getDB();
	$db->execute('replace into plug values(?,?,?,?,?)',
	($self->{MS}->getCGI->param('blogid').'',$plug,$dir,$file,$data));
}

sub existsPlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;

	my $db=$self->{MS}->getConfig->getDB();
	my @line=$db->execute('select * from plug  where blogid=? and plug=? and dir=? and file=?',
	($self->{MS}->getCGI->param('blogid').'',$plug,$dir,$file));

	if(@line){
		return 1;
	}else{
		return 0;
	}
}

sub readPlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;

	my $db=$self->{MS}->getConfig->getDB();
	my @line=$db->execute('select * from plug  where blogid=? and plug=? and dir=? and file=?',
	($self->{MS}->getCGI->param('blogid').'',$plug,$dir,$file));
	if(defined($line[0])){
		return split(/\n/,$line[0]->{data});
	}else{
		return ();
	}
}

sub deletePlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;

	my $db=$self->{MS}->getConfig->getDB();
	my @line=$db->execute('delete from plug  where blogid=? and plug=? and dir=? and file=?',
	($self->{MS}->getCGI->param('blogid').'',$plug,$dir,$file));
}

sub getPlugDirs{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;
	my $d=$self->{MS}->getPlugDataDir();
	$dir=~s/^$d//;

	my $db=$self->{MS}->getConfig->getDB();
	if($dir){
		$dir="and  dir like '$dir%' ";
	}
	my @line=$db->execute("select * from plug_dir where blogid=? $dir order by dir",
	($self->{MS}->getCGI->param('blogid').'')
	);

	foreach my $v(@line){
		$dircheck->{$d.$v->{dir}}=1;
	}

	return $dircheck;
}

sub getPlugDirFiles{
	my $self=shift;
	my $dir=shift;
	my $files=shift;

	my $d=$self->{MS}->getPlugDataDir();
	$dir=~s/^$d//;

	my $db=$self->{MS}->getConfig->getDB();

	my @line=$db->execute('select plug,dir,file from plug where blogid=? and dir=?',
	($self->{MS}->getCGI->param('blogid').'',$dir)
	);
	foreach(@line){
		$files->{$d."/$_->{plug}$_->{dir}/$_->{file}"}=1;
	}

	return $files;
}

1;
