package Msm::MySql;
use strict;
#use Time::HiRes qw/gettimeofday tv_interval/;

sub new{
	my $self=shift;
	my $adconfig=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{DBCLASS}=$adconfig;
	$hash->{DB}=undef;
	return $hash;
}

sub connect{
	my $self=shift;
	if($self->{DB}){
		return;
	}
	#print "Connect\n";
	my $db=undef;
	eval q`use DBI;
	$db=DBI->connect('DBI:mysql:'.$self->{DBCLASS}->getConfigData('','dbname').':'.$self->{DBCLASS}->getConfigData('','dbhost'),$self->{DBCLASS}->getConfigData('','dbuser'),$self->{DBCLASS}->getConfigData('','dbpass'));
	`;

	$self->{DB}=$db;

	#5p GĂX[
	eval{
		$self->execute('set names sjis');
	};
}

sub disconnect{
	my $self=shift;
	if($self->{DB}){
		$self->{DB}->disconnect;
		$self->{DB}=undef;
		#print "Close\n";
	}
}

sub execute{
	my $self=shift;
	my $query=shift;
	my @data=@_;

	#my $start=[gettimeofday];

	unless($self->{DB}){
		$self->connect();
	}
	$query=~s/\?/q{'}.$self->escape(shift @data).q{'}/ego;
	my $st=$self->{DB}->prepare($query);
	$st->execute || die $st->errstr;
	my @line=();
	if($query=~/^\s*select/i){

		while(my $href=$st->fetchrow_hashref){
			push @line,$href;
		}
		$st->finish;
	}
	$st->finish;

	#my $end=[gettimeofday];
	#my $speed=tv_interval($start, $end);
	#printf "sql time($query) %.6f b<br>\n", $speed;

	return @line;

}

sub escape{
	my $self=shift;
	my $text=shift;
	if(defined $text){
		$text=~s/\\/\\\\/g;
		$text=~s/'/\\'/g;
		return $text;
	}else{
		return '';
	}

}

1;
