package Msm::Config;

use strict;
use Msm::IO;

#
#	new
#
sub new{
	my $self=shift;
	my $filename=shift;
	my $adconfig=shift;
	my $db=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{DB}=$db;

	if($filename ne 'AdminConfig' && !($adconfig) && $filename ne 'Config'){
		$adconfig=new Msm::Config('AdminConfig',{});
	}
	if($filename eq 'AdminConfig' || $filename eq 'Config'){
		eval('use Msm::Config::File;');
		eval('$hash->{DBCLASS}=new Msm::Config::File($hash,{});');
	}else{
		eval('use Msm::Config::'.$adconfig->getConfigData('','savename').';');
		eval('$hash->{DBCLASS}=new Msm::Config::'.$adconfig->getConfigData('','savename').'($hash,$adconfig);');
	}
	$hash->{DATA}={};
	$hash->{LIST}=[]; #Ԃێ邧
	$hash->{FILENAME}=$filename;
	$hash->{NEW}=0;
	$hash->_readConfig();

	return $hash;
}

sub getDB{
	my $self=shift;
	return $self->{DB};
}

sub getNew{
	my $self=shift;
	return $self->{NEW};
}

#f[^m}bv擾B
sub getAllConfigDataMap(){
	my $self=shift;
	return $self->{DATA};
}

sub getAllConfigDataList(){
	my $self=shift;
	return @{$self->{LIST}};
}

#
#	RtBÕf[^擾
#
sub getConfigData(){
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	$plug='' if !defined($plug);
	$plug='default' unless($plug);
	return defined($self->{DATA}->{$plug}->{$name}->{value})?$self->{DATA}->{$plug}->{$name}->{value}:'';
}

sub getConfigInfo(){
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	$plug='' if !defined($plug);

	$plug='default' unless($plug);


	return defined($self->{DATA}->{$plug}->{$name}->{info})?$self->{DATA}->{$plug}->{$name}->{info}:'';
}

#
#	RtBÕf[^Zbg(㏑Ȃj
#
sub setConfigData(){
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	my $info=shift;
	my $value=shift;

	if(defined $self->{DATA}->{$plug}->{$name}->{value}){
		$self->{DATA}->{$plug}->{$name}->{info}=$info;
		return;
	}

	push @{$self->{LIST}},$plug.'.'.$name;

	$self->{DATA}->{$plug}->{$name}->{value}=$value;
	$self->{DATA}->{$plug}->{$name}->{info}=$info;
}

#
#	RtBÕf[^Zbg(㏑j
#
sub setConfigDataOverWrite(){
	my $self=shift;
	my $plug=shift;
	my $name=shift;
	my $info=shift;
	my $value=shift;

	unless(defined $self->{DATA}->{$plug}->{$name}->{value}){
		push @{$self->{LIST}},$plug.'.'.$name;
	}

	$self->{DATA}->{$plug}->{$name}->{value}=$value;
	$self->{DATA}->{$plug}->{$name}->{info}=$info;
}

#
#	RtBOtextǂݍ
#
sub _readConfig(){

	my $self=shift;

	$self->{DBCLASS}->readConfig();
}

#
#	RtBOf[^ȂB
#
sub rewriteConfig(){
	my $self=shift;
	my $hash=shift;
	my $fileperm=shift;

	$self->{DBCLASS}->rewriteConfig($hash,$fileperm);
}

1;
