#!/usr/local/bin/perl

use strict;
use Msm::CGI;
use CGI::Carp qw(fatalsToBrowser set_message);
use Msm::Config;
use Msm::MySql;

if($ENV{'MOD_PERL'}){
	my $sf=$ENV{SCRIPT_FILENAME};
	if($sf=~/^(.*)\/.*$/){
		chdir $1;
	}
}

my $cgi=new Msm::CGI();
eval{
	$cgi->charset('Shift_JIS');
};

my $bid=$cgi->param('blogid');

my $adconfig=new Msm::Config('Config',{},{});
my $mysql=new Msm::MySql($adconfig);
my $config=new Msm::Config('Config',$adconfig,$mysql);

my $io=new Msm::IO($adconfig->getConfigData('','fileperm'),$adconfig->getConfigData('','dirperm'));
my $efile=$cgi->param('efile');
my $edir=$cgi->param('edir');
my $edate=$cgi->param('edate');

my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$year+=1900;
$mon++;
my $fdate=sprintf('%04d%02d%02d',$year,$mon,$day);

$io->createDir($adconfig->getConfigData('','plugdatadir').'/EazyAnalyzer/dummy');

my $t=$cgi->param('tt');
if($config->getConfigData('EazyAnalyzer','useflg') ne '0'){
	if($t eq 'index'){
		&write($adconfig->getConfigData('','plugdatadir').'/EazyAnalyzer/'.$fdate.'.txt','index<>index',$adconfig,$cgi,$io,$mysql);
	}elsif($t eq 'category'){
		&write($adconfig->getConfigData('','plugdatadir').'/EazyAnalyzer/'.$fdate.'.txt','category<>'.$edir,$adconfig,$cgi,$io,$mysql);
	}elsif($t eq 'sketch'){
		&write($adconfig->getConfigData('','plugdatadir').'/EazyAnalyzer/'.$fdate.'.txt','sketch<>'.$efile,$adconfig,$cgi,$io,$mysql);
	}elsif($t eq 'day'){
		&write($adconfig->getConfigData('','plugdatadir').'/EazyAnalyzer/'.$fdate.'.txt','day<>'.$edate,$adconfig,$cgi,$io,$mysql);
	}elsif($t eq 'month'){
		&write($adconfig->getConfigData('','plugdatadir').'/EazyAnalyzer/'.$fdate.'.txt','month<>'.$edate,$adconfig,$cgi,$io,$mysql);
	}
}

print 'Content-type: image/gif'."\n\n";
my $data=$io->readFile($config->getConfigData('','staticindexdir').'files/eazyanalyzer.gif',1);
print $data;

exists($ENV{'MOD_PERL'})?Apache::exit(0):CORE::exit(0);

sub write{
	my $file=shift;
	my $page=shift;
	my $adconfig=shift;
	my $cgi=shift;
	my $io=shift;
	my $mysql=shift;
	
	my $refe=$ENV{QUERY_STRING};

	$refe=~s/^.*ref=(.*)\&efile=.*$/$1/s;
	my $word='';
	my $code='';
	my $path=$adconfig->getConfigData('','script');
	my $path2=$adconfig->getConfigData('','staticindexurl');
	$path=~s/^(.*\/).*$/$1/;
	if($refe =~ /$ENV{HTTP_HOST}$path/ || $refe =~ /$ENV{HTTP_HOST}$path2/){
		$refe='';
	}
	else{
	# T[`GW̃t@
		# Google
		if($refe =~ /http\:.+\.google\..+\/(search|ie|custom)\?(.*?&|)q=([^&]+)/o){
			$word=$3;
		}
		# Yahoo!
		elsif($refe =~ /http\:.+\.yahoo\..+\/.+\?(.*?&|)p=([^&]+)/o){
			$word=$2;
		}
		# BIGLOBE
		elsif($refe =~ /http\:.+\.search\.biglobe\..+\/.+\?(.*?&|)q=([^&]+)/o){
			$word=$2;
			$code='euc';
		}
		# Goo
		elsif($refe =~ /http\:.+\.goo\..+\/.+\?(.*?&|)MT=([^&]+)/o){
			$word=$2;
		}
		# infoseek
		elsif($refe =~ /http\:.+\.infoseek\..+\/.+\?(.*?&|)qt=([^&]+)/o){
			$word=$2;
		}
		# Excite
		elsif($refe =~ /http\:.+\.excite\..+\/.+\?(.*?&|)search=([^&]+)/o){
			$word=$2;
		}
		# Live Search
		elsif($refe =~ /http\:.+\.(msn|live)\..+\/.+\?(.*?&|)q=([^&]+)/o){
			$word=$3;
		}
		# Nifty
		elsif($refe =~ /http\:.+\.nifty\..+\/.+\?(.*?&|)Text=([^&]+)/o){
			$word=$2;
		}
	# ̑̃t@
		# track word
		elsif($refe =~ /http\:.+\.track-word\..+\/k\/(.+)/o){
			$word=$1;
		}
		if($word){
			use Msm::MySketch;
			use Msm::JCodeFunction;
			my $jcode=new Msm::JCodeFunction($adconfig);
			my $ms=new Msm::MySketch($cgi,$config,$io,$config,$mysql,$jcode);
			$word=$cgi->unescape($word);
			my $word2=$jcode->JCodeConvert($ms,$word,'sjis','utf8');
			my $word3=$jcode->JCodeConvert($ms,$word,'sjis',$code);
			my $code2=($code eq '')?$jcode->JCodeGet($ms,$word):'';
			if($word eq $jcode->JCodeConvert($ms,$word2,'utf8','sjis') || $code2 eq 'utf8'){
				$word=$word2;
			}
			elsif($word ne $word3 && ($code ne '' || $code2 ne 'sjis')){
				$word=$word3;
			}
		}
	}

	$io->writeFileAdd($file,$refe.'<>'.time.'<>'.$page.'<>'.$word."\n");
}
